
#ifndef __WINMAIN_H_
#define __WINMAIN_H_
/**************************************************************************************
* This file is part of the FrameworkTest project released by Wazoo Enterprises Inc.
* under the GNU Public License. 
*
* Any projects using this code must attach these copyright notices along with their
* own as outlined at http://www.gnu.org
*
* Copyright 2001-2003 by Wazoo Enterprises Inc.
* To contact the auther, send a message to wazoo@wazooenterprises.com
*
****************************************************************************************/

/**
* NOTE: Be sure to put the GameFramework/include folder in the path of your include
* files!
*/
#include "GameFramework.h"


class CTestApp {

private:
	BOOL m_bActive;
	HWND	m_hWnd;
	HINSTANCE m_hInstance;
	std::string m_strAppClass;
	std::string m_strAppTitle;

	rendererFactory* m_pGraphicsFactory;


public:
	CTestApp();
	~CTestApp();

	HRESULT initSystem(HINSTANCE, std::string, std::string);
	int runSystem(void);

	LRESULT CALLBACK wndProc(HWND, UINT, WPARAM, LPARAM);
	HRESULT createProgram();
	void updateProgram(FLOAT);
	void renderProgram(void);
	void destroyProgram(void);

};


#endif
