/**************************************************************************************
* This file is part of the GameFramework project released by Wazoo Enterprises Inc.
* under the GNU Public License. 
*
* Any projects using this code must attach these copyright notices along with their
* own as outlined at http://www.gnu.org
*
* Copyright 2003 by Wazoo Enterprises Inc.
* To contact the auther, send a message to wazoo@wazooenterprises.com
*
****************************************************************************************/


#pragma warning(disable: 4786)

#include "D3DTextureManager.h"

D3DTextureManager::D3DTextureManager(LPDIRECT3DDEVICE8 pDevice) :
		m_lpD3DDevice(pDevice) {


}

D3DTextureManager::~D3DTextureManager(){

	for(std::map<int, LPDIRECT3DTEXTURE8>::iterator it = m_oTextures.begin(); 
		it != m_oTextures.end();
		it++){

		if(&it->second ){
		   it->second->Release();
		   it->second = NULL;
		}

	}

	m_oTextures.clear();

}

HRESULT D3DTextureManager::addTexture(std::string strFilename, 
									  const int value){


	HRESULT hr;

	LPDIRECT3DTEXTURE8 tex = NULL;

	if(FAILED(hr = D3DXCreateTextureFromFile(m_lpD3DDevice,
											 strFilename.c_str(),
											 &tex))){
		return hr;
	}
	
	m_oTextures.insert(std::make_pair(value, tex));

	return S_OK;
}


void D3DTextureManager::setTexture(const int value){

	std::map<int, LPDIRECT3DTEXTURE8>::iterator it;
	it = m_oTextures.find(value);
	if (it == m_oTextures.end()) { // not found!
		return;
	}
	else {
		
		m_lpD3DDevice->SetTexture(0, it->second);

	}


}