
#include "Logger.h"

Logger* Logger::m_pInstance = NULL;

Logger::Logger()
{
    m_hFile = NULL;
	m_bLoggingSupported = FALSE;
}

Logger::~Logger()
{
    CloseHandle(m_hFile);
}

Logger* Logger::getInstance()
{
	if(NULL == m_pInstance)
	{
		m_pInstance = new Logger();
	}

	return m_pInstance;
}

BOOL Logger::openLog(LPCSTR logFile)
{
    m_hFile = CreateFile(logFile,           // open MYFILE.TXT 
                GENERIC_WRITE,              // open for reading 
                0,           // share for reading 
                NULL,                      // no security 
                CREATE_ALWAYS,             // existing file only 
                FILE_ATTRIBUTE_NORMAL,         // asynchronous I/O 
            
                NULL);                     // no attr. template 
 
	if (m_hFile == INVALID_HANDLE_VALUE) 
	{ 
		return FALSE; 
	}

	m_bLoggingSupported = TRUE;
 
	return TRUE;
 }
 
 
DWORD Logger::writeToLog(LPCSTR strToWrite)
{
    DWORD dwBytesWritten = 0;
    DWORD dwBytesToWrite = 0;
    
	if(!m_bLoggingSupported)
		return -1;

    dwBytesToWrite = (DWORD)strlen(strToWrite);
    WriteFile(m_hFile, strToWrite, dwBytesToWrite, 
            &dwBytesWritten, NULL);
   
	WriteFile(m_hFile, "\r\n", (DWORD)strlen("\r\n"), &dwBytesWritten, NULL);

    return dwBytesWritten;
}
